/*
 *         
 * $Id:$
 * 
 * $Copyright: (c) 2016 Broadcom.
 * Broadcom Proprietary and Confidential. All rights reserved.$
 *         
 *     
 * DO NOT EDIT THIS FILE!
 *
 */

#ifndef _PORTMOD_DISPATCH_H__H_
#define _PORTMOD_DISPATCH_H__H_

#include <phymod/phymod.h>
#include <phymod/phymod_diagnostics.h>
#include <soc/portmod/portmod_defs.h>
#include <soc/portmod/portmod.h>

typedef int (*__dispatch__portmod_pm_interface_type_is_supported_f)(int unit, soc_port_if_t interface, int* is_supported);
typedef int (*__dispatch__portmod_pm_init_f)(int unit, const portmod_pm_create_info_internal_t* pm_add_info, int wb_buffer_index, pm_info_t pm_info);
typedef int (*__dispatch__portmod_pm_destroy_f)(int unit, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_attach_f)(int unit, int port, pm_info_t pm_info, const portmod_port_add_info_t* add_info);
typedef int (*__dispatch__portmod_default_bus_update_f)(int unit, pm_info_t pm_info, const portmod_bus_update_t* update);
typedef int (*__dispatch__portmod_pm_bypass_set_f)(int unit, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_pm_core_info_get_f)(int unit, pm_info_t pm_info, int phyn, portmod_pm_core_info_t* core_info);
typedef int (*__dispatch__portmod_pm_phys_get_f)(int unit, pm_info_t pm_info, portmod_pbmp_t* phys);
typedef int (*__dispatch__portmod_port_detach_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_replace_f)(int unit, int port, pm_info_t pm_info, int new_port);
typedef int (*__dispatch__portmod_port_enable_set_f)(int unit, int port, pm_info_t pm_info, int flags, int enable);
typedef int (*__dispatch__portmod_port_enable_get_f)(int unit, int port, pm_info_t pm_info, int flags, int* enable);
typedef int (*__dispatch__portmod_port_interface_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_port_interface_config_t* config, int phy_init_flags);
typedef int (*__dispatch__portmod_port_interface_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_interface_config_t* config, int phy_init_flags);
typedef int (*__dispatch__portmod_port_default_interface_get_f)(int unit, int port, pm_info_t pm_info, const portmod_port_interface_config_t* config, soc_port_if_t* interface);
typedef int (*__dispatch__portmod_port_encoding_set_f)(int unit, int port, pm_info_t pm_info, uint32 properties, portmod_port_pcs_t encoding);
typedef int (*__dispatch__portmod_port_encoding_get_f)(int unit, int port, pm_info_t pm_info, uint32* properties, portmod_port_pcs_t* encoding);
typedef int (*__dispatch__portmod_port_cl72_set_f)(int unit, int port, pm_info_t pm_info, uint32 enable);
typedef int (*__dispatch__portmod_port_cl72_get_f)(int unit, int port, pm_info_t pm_info, uint32* enable);
typedef int (*__dispatch__portmod_port_cl72_status_get_f)(int unit, int port, pm_info_t pm_info, phymod_cl72_status_t* status);
typedef int (*__dispatch__portmod_port_loopback_set_f)(int unit, int port, pm_info_t pm_info, portmod_loopback_mode_t loopback_type, int enable);
typedef int (*__dispatch__portmod_port_loopback_get_f)(int unit, int port, pm_info_t pm_info, portmod_loopback_mode_t loopback_type, int* enable);
typedef int (*__dispatch__portmod_port_rx_mac_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_rx_mac_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_tx_mac_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_tx_mac_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_ability_local_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_autoneg_set_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, const phymod_autoneg_control_t* an);
typedef int (*__dispatch__portmod_port_autoneg_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, phymod_autoneg_control_t* an);
typedef int (*__dispatch__portmod_port_autoneg_status_get_f)(int unit, int port, pm_info_t pm_info, phymod_autoneg_status_t* an_status);
typedef int (*__dispatch__portmod_port_link_get_f)(int unit, int port, pm_info_t pm_info, int flags, int* link);
typedef int (*__dispatch__portmod_port_link_latch_down_get_f)(int unit, int port, pm_info_t pm_info, uint32 flags, int* link);
typedef int (*__dispatch__portmod_port_phy_link_up_event_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_phy_link_down_event_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_prbs_config_set_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, const phymod_prbs_t* config);
typedef int (*__dispatch__portmod_port_prbs_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, phymod_prbs_t* config);
typedef int (*__dispatch__portmod_port_prbs_enable_set_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, int enable);
typedef int (*__dispatch__portmod_port_prbs_enable_get_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, int* enable);
typedef int (*__dispatch__portmod_port_prbs_status_get_f)(int unit, int port, pm_info_t pm_info, portmod_prbs_mode_t mode, int flags, phymod_prbs_status_t* status);
typedef int (*__dispatch__portmod_port_nof_lanes_get_f)(int unit, int port, pm_info_t pm_info, int* nof_lanes);
typedef int (*__dispatch__portmod_port_ilkn_nof_segments_set_f)(int unit, int port, pm_info_t pm_info, uint32 nof_segments);
typedef int (*__dispatch__portmod_port_ilkn_nof_segments_get_f)(int unit, int port, pm_info_t pm_info, uint32* nof_segments);
typedef int (*__dispatch__portmod_ilkn_retranstmit_config_set_f)(int unit, int port, pm_info_t pm_info, const ilkn_retransmit_config_t* retransmit_config);
typedef int (*__dispatch__portmod_ilkn_retranstmit_config_get_f)(int unit, int port, pm_info_t pm_info, ilkn_retransmit_config_t* retransmit_config);
typedef int (*__dispatch__portmod_port_lanes_assign_f)(int unit, int port, pm_info_t pm_info, const portmod_lanes_assign_info_t* assign_map);
typedef int (*__dispatch__portmod_port_lanes_retrieve_f)(int unit, int port, pm_info_t pm_info, portmod_lanes_assign_info_t* assign_map);
typedef int (*__dispatch__portmod_port_firmware_mode_set_f)(int unit, int port, pm_info_t pm_info, phymod_firmware_mode_t fw_mode);
typedef int (*__dispatch__portmod_port_firmware_mode_get_f)(int unit, int port, pm_info_t pm_info, phymod_firmware_mode_t* fw_mode);
typedef int (*__dispatch__portmod_port_runt_threshold_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_runt_threshold_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_max_packet_size_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_max_packet_size_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_pad_size_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_pad_size_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_tx_mac_sa_set_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_tx_mac_sa_get_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_rx_mac_sa_set_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_rx_mac_sa_get_f)(int unit, int port, pm_info_t pm_info, sal_mac_addr_t mac_sa);
typedef int (*__dispatch__portmod_port_tx_average_ipg_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_tx_average_ipg_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_tx_preamble_length_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_tx_preamble_length_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_local_fault_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_local_fault_control_t* control);
typedef int (*__dispatch__portmod_port_local_fault_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_local_fault_control_t* control);
typedef int (*__dispatch__portmod_port_remote_fault_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_remote_fault_control_t* control);
typedef int (*__dispatch__portmod_port_remote_fault_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_remote_fault_control_t* control);
typedef int (*__dispatch__portmod_port_local_fault_status_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_remote_fault_status_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_local_fault_status_clear_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_remote_fault_status_clear_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_pause_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_pause_control_t* control);
typedef int (*__dispatch__portmod_port_pause_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_pause_control_t* control);
typedef int (*__dispatch__portmod_port_pfc_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_pfc_control_t* control);
typedef int (*__dispatch__portmod_port_pfc_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_pfc_control_t* control);
typedef int (*__dispatch__portmod_port_llfc_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_llfc_control_t* control);
typedef int (*__dispatch__portmod_port_llfc_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_llfc_control_t* control);
typedef int (*__dispatch__portmod_port_update_f)(int unit, int port, pm_info_t pm_info, const portmod_port_update_control_t* update_control);
typedef int (*__dispatch__portmod_port_core_access_get_f)(int unit, int port, pm_info_t pm_info, int phyn, int max_cores, phymod_core_access_t* core_access_arr, int* nof_cores, int* is_most_ext);
typedef int (*__dispatch__portmod_port_phy_lane_access_get_f)(int unit, int port, pm_info_t pm_info, const portmod_access_get_params_t* params, int max_phys, phymod_phy_access_t* access, int* nof_phys, int* is_most_ext);
typedef int (*__dispatch__portmod_port_duplex_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_duplex_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_phy_reg_read_f)(int unit, int port, pm_info_t pm_info, int flags, int reg_addr, uint32* value);
typedef int (*__dispatch__portmod_port_phy_reg_write_f)(int unit, int port, pm_info_t pm_info, int flags, int reg_addr, uint32 value);
typedef int (*__dispatch__portmod_port_reset_set_f)(int unit, int port, pm_info_t pm_info, int mode, int opcode, int value);
typedef int (*__dispatch__portmod_port_reset_get_f)(int unit, int port, pm_info_t pm_info, int mode, int opcode, int* value);
typedef int (*__dispatch__portmod_port_adv_remote_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_drv_name_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_drv_name_get_f)(int unit, int port, pm_info_t pm_info, char* name, int len);
typedef int (*__dispatch__portmod_port_fec_enable_set_f)(int unit, int port, pm_info_t pm_info, uint32_t enable);
typedef int (*__dispatch__portmod_port_fec_enable_get_f)(int unit, int port, pm_info_t pm_info, uint32_t* enable);
typedef int (*__dispatch__portmod_port_ability_advert_set_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_ability_advert_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_ability_remote_get_f)(int unit, int port, pm_info_t pm_info, uint32 phy_flags, portmod_port_ability_t* ability);
typedef int (*__dispatch__portmod_port_frame_spacing_stretch_set_f)(int unit, int port, pm_info_t pm_info, int spacing);
typedef int (*__dispatch__portmod_port_frame_spacing_stretch_get_f)(int unit, int port, pm_info_t pm_info, const int* spacing);
typedef int (*__dispatch__portmod_port_diag_fifo_status_get_f)(int unit, int port, pm_info_t pm_info, const portmod_fifo_status_t* diag_info);
typedef int (*__dispatch__portmod_port_rx_control_set_f)(int unit, int port, pm_info_t pm_info, const portmod_rx_control_t* rx_ctrl);
typedef int (*__dispatch__portmod_port_rx_control_get_f)(int unit, int port, pm_info_t pm_info, portmod_rx_control_t* rx_ctrl);
typedef int (*__dispatch__portmod_port_pfc_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_pfc_config_t* pfc_cfg);
typedef int (*__dispatch__portmod_port_pfc_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_pfc_config_t* pfc_cfg);
typedef int (*__dispatch__portmod_port_eee_set_f)(int unit, int port, pm_info_t pm_info, const portmod_eee_t* eee);
typedef int (*__dispatch__portmod_port_eee_get_f)(int unit, int port, pm_info_t pm_info, portmod_eee_t* eee);
typedef int (*__dispatch__portmod_port_eee_clock_set_f)(int unit, int port, pm_info_t pm_info, const portmod_eee_clock_t* eee_clk);
typedef int (*__dispatch__portmod_port_eee_clock_get_f)(int unit, int port, pm_info_t pm_info, portmod_eee_clock_t* eee_clk);
typedef int (*__dispatch__portmod_port_vlan_tag_set_f)(int unit, int port, pm_info_t pm_info, const portmod_vlan_tag_t* vlan_tag);
typedef int (*__dispatch__portmod_port_vlan_tag_get_f)(int unit, int port, pm_info_t pm_info, portmod_vlan_tag_t* vlan_tag);
typedef int (*__dispatch__portmod_port_modid_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_led_chain_config_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_clear_rx_lss_status_set_f)(int unit, int port, pm_info_t pm_info, int lcl_fault, int rmt_fault);
typedef int (*__dispatch__portmod_port_clear_rx_lss_status_get_f)(int unit, int port, pm_info_t pm_info, int* lcl_fault, int* rmt_fault);
typedef int (*__dispatch__portmod_xphy_lane_attach_to_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, const portmod_xphy_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_xphy_lane_detach_from_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, portmod_xphy_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_ext_phy_lane_attach_to_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, const portmod_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_ext_phy_lane_detach_from_pm_f)(int unit, pm_info_t pm_info, int iphy, int phyn, portmod_lane_connection_t* lane_connection);
typedef int (*__dispatch__portmod_port_lag_failover_status_toggle_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_lag_failover_loopback_set_f)(int unit, int port, pm_info_t pm_info, int value);
typedef int (*__dispatch__portmod_port_lag_failover_loopback_get_f)(int unit, int port, pm_info_t pm_info, int* value);
typedef int (*__dispatch__portmod_port_mode_set_f)(int unit, int port, pm_info_t pm_info, const portmod_port_mode_info_t* mode);
typedef int (*__dispatch__portmod_port_mode_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_mode_info_t* mode);
typedef int (*__dispatch__portmod_port_encap_set_f)(int unit, int port, pm_info_t pm_info, int flags, portmod_encap_t encap);
typedef int (*__dispatch__portmod_port_encap_get_f)(int unit, int port, pm_info_t pm_info, int* flags, portmod_encap_t* encap);
typedef int (*__dispatch__portmod_port_higig_mode_set_f)(int unit, int port, pm_info_t pm_info, int mode);
typedef int (*__dispatch__portmod_port_higig_mode_get_f)(int unit, int port, pm_info_t pm_info, int* mode);
typedef int (*__dispatch__portmod_port_higig2_mode_set_f)(int unit, int port, pm_info_t pm_info, int mode);
typedef int (*__dispatch__portmod_port_higig2_mode_get_f)(int unit, int port, pm_info_t pm_info, int* mode);
typedef int (*__dispatch__portmod_port_config_port_type_set_f)(int unit, int port, pm_info_t pm_info, int type);
typedef int (*__dispatch__portmod_port_config_port_type_get_f)(int unit, int port, pm_info_t pm_info, int* type);
typedef int (*__dispatch__portmod_port_trunk_hwfailover_config_set_f)(int unit, int port, pm_info_t pm_info, int hw_count);
typedef int (*__dispatch__portmod_port_trunk_hwfailover_config_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_trunk_hwfailover_status_get_f)(int unit, int port, pm_info_t pm_info, int* loopback);
typedef int (*__dispatch__portmod_port_diag_ctrl_f)(int unit, int port, pm_info_t pm_info, uint32 inst, int op_type, int op_cmd, const void* arg);
typedef int (*__dispatch__portmod_port_ref_clk_get_f)(int unit, int port, pm_info_t pm_info, int* ref_clk);
typedef int (*__dispatch__portmod_port_lag_failover_disable_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_lag_remove_failover_lpbk_set_f)(int unit, int port, pm_info_t pm_info, int val);
typedef int (*__dispatch__portmod_port_lag_remove_failover_lpbk_get_f)(int unit, int port, pm_info_t pm_info, int* val);
typedef int (*__dispatch__portmod_port_cntmaxsize_set_f)(int unit, int port, pm_info_t pm_info, int val);
typedef int (*__dispatch__portmod_port_cntmaxsize_get_f)(int unit, int port, pm_info_t pm_info, int* val);
typedef int (*__dispatch__portmod_port_multi_get_f)(int unit, int port, pm_info_t pm_info, portmod_multi_get_t* multi_get);
typedef int (*__dispatch__portmod_port_drain_cell_get_f)(int unit, int port, pm_info_t pm_info, portmod_drain_cells_t* drain_cells);
typedef int (*__dispatch__portmod_port_drain_cell_stop_f)(int unit, int port, pm_info_t pm_info, const portmod_drain_cells_t* drain_cells);
typedef int (*__dispatch__portmod_port_drain_cell_start_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_drain_cells_rx_enable_f)(int unit, int port, pm_info_t pm_info, int rx_en);
typedef int (*__dispatch__portmod_port_egress_queue_drain_rx_en_f)(int unit, int port, pm_info_t pm_info, int rx_en);
typedef int (*__dispatch__portmod_port_mac_ctrl_set_f)(int unit, int port, pm_info_t pm_info, uint64 ctrl);
typedef int (*__dispatch__portmod_port_txfifo_cell_cnt_get_f)(int unit, int port, pm_info_t pm_info, uint32* cnt);
typedef int (*__dispatch__portmod_port_egress_queue_drain_get_f)(int unit, int port, pm_info_t pm_info, uint64* ctrl, int* rxen);
typedef int (*__dispatch__portmod_port_mac_reset_set_f)(int unit, int port, pm_info_t pm_info, int val);
typedef int (*__dispatch__portmod_port_soft_reset_toggle_f)(int unit, int port, pm_info_t pm_info, int idx);
typedef int (*__dispatch__portmod_port_mac_reset_check_f)(int unit, int port, pm_info_t pm_info, int enable, int* reset);
typedef int (*__dispatch__portmod_port_core_num_get_f)(int unit, int port, pm_info_t pm_info, int* core_num);
typedef int (*__dispatch__portmod_port_e2ecc_hdr_set_f)(int unit, int port, pm_info_t pm_info, const portmod_port_higig_e2ecc_hdr_t* e2ecc_hdr);
typedef int (*__dispatch__portmod_port_e2ecc_hdr_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_higig_e2ecc_hdr_t* e2ecc_hdr);
typedef int (*__dispatch__portmod_port_e2e_enable_set_f)(int unit, int port, pm_info_t pm_info, int enable);
typedef int (*__dispatch__portmod_port_e2e_enable_get_f)(int unit, int port, pm_info_t pm_info, int* enable);
typedef int (*__dispatch__portmod_port_fallback_lane_get_f)(int unit, int port, pm_info_t pm_info, int* fallback_lane);
typedef int (*__dispatch__portmod_port_speed_get_f)(int unit, int port, pm_info_t pm_info, int* speed);
typedef int (*__dispatch__portmod_port_tsc_refclock_set_f)(int unit, int port, pm_info_t pm_info, int ref_in, int ref_out);
typedef int (*__dispatch__portmod_port_tsc_refclock_get_f)(int unit, int port, pm_info_t pm_info, int* ref_in, int* ref_out);
typedef int (*__dispatch__portmod_port_discard_set_f)(int unit, int port, pm_info_t pm_info, int discard);
typedef int (*__dispatch__portmod_port_soft_reset_set_f)(int unit, int port, pm_info_t pm_info, int idx, int val, int flags);
typedef int (*__dispatch__portmod_port_tx_down_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_logical_lane_order_set_f)(int unit, int port, pm_info_t pm_info, const int* lane_order, int lane_order_size);
typedef int (*__dispatch__portmod_port_logical_lane_order_get_f)(int unit, int port, pm_info_t pm_info, int lane_order_max_size, int* lane_order, int* lane_order_actual_size);
typedef int (*__dispatch__portmod_port_pgw_reconfig_f)(int unit, int port, pm_info_t pm_info, const portmod_port_mode_info_t* pmode, int phy_port, int flags);
typedef int (*__dispatch__portmod_port_notify_f)(int unit, int port, pm_info_t pm_info, int link);
typedef int (*__dispatch__portmod_port_control_phy_timesync_set_f)(int unit, int port, pm_info_t pm_info, portmod_port_control_phy_timesync_t config, uint64 value);
typedef int (*__dispatch__portmod_port_control_phy_timesync_get_f)(int unit, int port, pm_info_t pm_info, portmod_port_control_phy_timesync_t config, uint64* value);
typedef int (*__dispatch__portmod_port_timesync_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_phy_timesync_config_t* config);
typedef int (*__dispatch__portmod_port_timesync_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_phy_timesync_config_t* config);
typedef int (*__dispatch__portmod_port_timesync_enable_set_f)(int unit, int port, pm_info_t pm_info, uint32 enable);
typedef int (*__dispatch__portmod_port_timesync_enable_get_f)(int unit, int port, pm_info_t pm_info, uint32* enable);
typedef int (*__dispatch__portmod_port_timesync_nco_addend_set_f)(int unit, int port, pm_info_t pm_info, uint32 freq_step);
typedef int (*__dispatch__portmod_port_timesync_nco_addend_get_f)(int unit, int port, pm_info_t pm_info, uint32* freq_step);
typedef int (*__dispatch__portmod_port_timesync_framesync_mode_set_f)(int unit, int port, pm_info_t pm_info, const portmod_timesync_framesync_t* framesync);
typedef int (*__dispatch__portmod_port_timesync_framesync_mode_get_f)(int unit, int port, pm_info_t pm_info, portmod_timesync_framesync_t* framesync);
typedef int (*__dispatch__portmod_port_timesync_local_time_set_f)(int unit, int port, pm_info_t pm_info, uint64 local_time);
typedef int (*__dispatch__portmod_port_timesync_local_time_get_f)(int unit, int port, pm_info_t pm_info, uint64* local_time);
typedef int (*__dispatch__portmod_port_timesync_load_ctrl_set_f)(int unit, int port, pm_info_t pm_info, uint32 load_once, uint32 load_always);
typedef int (*__dispatch__portmod_port_timesync_load_ctrl_get_f)(int unit, int port, pm_info_t pm_info, uint32* load_once, uint32* load_always);
typedef int (*__dispatch__portmod_port_timesync_tx_timestamp_offset_set_f)(int unit, int port, pm_info_t pm_info, uint32 ts_offset);
typedef int (*__dispatch__portmod_port_timesync_tx_timestamp_offset_get_f)(int unit, int port, pm_info_t pm_info, uint32* ts_offset);
typedef int (*__dispatch__portmod_port_timesync_rx_timestamp_offset_set_f)(int unit, int port, pm_info_t pm_info, uint32 ts_offset);
typedef int (*__dispatch__portmod_port_timesync_rx_timestamp_offset_get_f)(int unit, int port, pm_info_t pm_info, uint32* ts_offset);
typedef int (*__dispatch__portmod_port_phy_intr_enable_set_f)(int unit, int port, pm_info_t pm_info, uint32 intr_enable);
typedef int (*__dispatch__portmod_port_phy_intr_enable_get_f)(int unit, int port, pm_info_t pm_info, uint32* intr_enable);
typedef int (*__dispatch__portmod_port_phy_intr_status_get_f)(int unit, int port, pm_info_t pm_info, uint32* intr_status);
typedef int (*__dispatch__portmod_port_phy_intr_status_clear_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_phy_timesync_do_sync_f)(int unit, int port, pm_info_t pm_info);
typedef int (*__dispatch__portmod_port_timesync_capture_timestamp_get_f)(int unit, int port, pm_info_t pm_info, uint64* cap_ts);
typedef int (*__dispatch__portmod_port_timesync_heartbeat_timestamp_get_f)(int unit, int port, pm_info_t pm_info, uint64* hb_ts);
typedef int (*__dispatch__portmod_port_edc_config_set_f)(int unit, int port, pm_info_t pm_info, const portmod_edc_config_t* config);
typedef int (*__dispatch__portmod_port_edc_config_get_f)(int unit, int port, pm_info_t pm_info, portmod_edc_config_t* config);
typedef int (*__dispatch__portmod_port_interrupt_enable_set_f)(int unit, int port, pm_info_t pm_info, int intr_type, uint32 val);
typedef int (*__dispatch__portmod_port_interrupt_enable_get_f)(int unit, int port, pm_info_t pm_info, int intr_type, uint32* val);
typedef int (*__dispatch__portmod_port_interrupt_get_f)(int unit, int port, pm_info_t pm_info, int intr_type, uint32* val);
typedef int (*__dispatch__portmod_port_interrupts_get_f)(int unit, int port, pm_info_t pm_info, int arr_max_size, uint32* intr_arr, uint32* size);
typedef int (*__dispatch__portmod_port_check_legacy_phy_f)(int unit, int port, pm_info_t pm_info, int* legacy_phy);
typedef int (*__dispatch__portmod_port_failover_mode_set_f)(int unit, int port, pm_info_t pm_info, phymod_failover_mode_t failover);
typedef int (*__dispatch__portmod_port_failover_mode_get_f)(int unit, int port, pm_info_t pm_info, phymod_failover_mode_t* failover);
typedef int (*__dispatch__portmod_port_mac_rsv_mask_set_f)(int unit, int port, pm_info_t pm_info, uint32 rsv_mask);
typedef int (*__dispatch__portmod_port_mib_reset_toggle_f)(int unit, int port, pm_info_t pm_info, int port_index);
typedef int (*__dispatch__portmod_port_warmboot_db_restore_f)(int unit, int port, pm_info_t pm_info, const portmod_port_interface_config_t* intf_config, const portmod_port_init_config_t* init_config, phymod_operation_mode_t phy_op_mode);
typedef int (*__dispatch__portmod_port_flow_control_set_f)(int unit, int port, pm_info_t pm_info, int merge_mode_en, int parallel_fc_en);
typedef int (*__dispatch__portmod_port_update_dynamic_state_f)(int unit, int port, pm_info_t pm_info, uint32_t port_dynamic_state);
typedef int (*__dispatch__portmod_port_phy_op_mode_get_f)(int unit, int port, pm_info_t pm_info, phymod_operation_mode_t* val);
typedef int (*__dispatch__portmod_port_lane_map_set_f)(int unit, int port, pm_info_t pm_info, const phymod_lane_map_t* lane_map);
typedef int (*__dispatch__portmod_port_lane_map_get_f)(int unit, int port, pm_info_t pm_info, phymod_lane_map_t* lane_map);
typedef int (*__dispatch__portmod_port_polarity_set_f)(int unit, int port, pm_info_t pm_info, const phymod_polarity_t* polarity);
typedef int (*__dispatch__portmod_port_polarity_get_f)(int unit, int port, pm_info_t pm_info, phymod_polarity_t* polarity);
typedef int (*__dispatch__portmod_port_medium_config_set_f)(int unit, int port, pm_info_t pm_info, soc_port_medium_t medium, soc_phy_config_t* config);
typedef int (*__dispatch__portmod_port_medium_config_get_f)(int unit, int port, pm_info_t pm_info, soc_port_medium_t medium, soc_phy_config_t* config);
typedef int (*__dispatch__portmod_port_medium_get_f)(int unit, int port, pm_info_t pm_info, soc_port_medium_t* medium);
typedef int (*__dispatch__portmod_pm_is_in_pm12x10_f)(int unit, pm_info_t pm_info, int* in_pm12x10);
typedef int (*__dispatch__portmod_slow_read_rate_set_f)(int unit, int port, pm_info_t pm_info, int slow_read_rate);
typedef int (*__dispatch__portmod_port_pll_div_get_f)(int unit, int port, const portmod_port_resources_t* port_resource, uint32_t* pll_div);
typedef int (*__dispatch__portmod_port_master_get_f)(int unit, int port, pm_info_t pm_info, int* master_mode);
typedef int (*__dispatch__portmod_port_lane_count_get_f)(int unit, int port, pm_info_t pm_info, int line_side, int* num_lanes);

typedef struct __portmod__dispatch__s__ {
    __dispatch__portmod_pm_interface_type_is_supported_f                             f_portmod_pm_interface_type_is_supported;
    __dispatch__portmod_pm_init_f                                                    f_portmod_pm_init;
    __dispatch__portmod_pm_destroy_f                                                 f_portmod_pm_destroy;
    __dispatch__portmod_port_attach_f                                                f_portmod_port_attach;
    __dispatch__portmod_default_bus_update_f                                         f_portmod_default_bus_update;
    __dispatch__portmod_pm_bypass_set_f                                              f_portmod_pm_bypass_set;
    __dispatch__portmod_pm_core_info_get_f                                           f_portmod_pm_core_info_get;
    __dispatch__portmod_pm_phys_get_f                                                f_portmod_pm_phys_get;
    __dispatch__portmod_port_detach_f                                                f_portmod_port_detach;
    __dispatch__portmod_port_replace_f                                               f_portmod_port_replace;
    __dispatch__portmod_port_enable_set_f                                            f_portmod_port_enable_set;
    __dispatch__portmod_port_enable_get_f                                            f_portmod_port_enable_get;
    __dispatch__portmod_port_interface_config_set_f                                  f_portmod_port_interface_config_set;
    __dispatch__portmod_port_interface_config_get_f                                  f_portmod_port_interface_config_get;
    __dispatch__portmod_port_default_interface_get_f                                 f_portmod_port_default_interface_get;
    __dispatch__portmod_port_encoding_set_f                                          f_portmod_port_encoding_set;
    __dispatch__portmod_port_encoding_get_f                                          f_portmod_port_encoding_get;
    __dispatch__portmod_port_cl72_set_f                                              f_portmod_port_cl72_set;
    __dispatch__portmod_port_cl72_get_f                                              f_portmod_port_cl72_get;
    __dispatch__portmod_port_cl72_status_get_f                                       f_portmod_port_cl72_status_get;
    __dispatch__portmod_port_loopback_set_f                                          f_portmod_port_loopback_set;
    __dispatch__portmod_port_loopback_get_f                                          f_portmod_port_loopback_get;
    __dispatch__portmod_port_rx_mac_enable_set_f                                     f_portmod_port_rx_mac_enable_set;
    __dispatch__portmod_port_rx_mac_enable_get_f                                     f_portmod_port_rx_mac_enable_get;
    __dispatch__portmod_port_tx_mac_enable_set_f                                     f_portmod_port_tx_mac_enable_set;
    __dispatch__portmod_port_tx_mac_enable_get_f                                     f_portmod_port_tx_mac_enable_get;
    __dispatch__portmod_port_ability_local_get_f                                     f_portmod_port_ability_local_get;
    __dispatch__portmod_port_autoneg_set_f                                           f_portmod_port_autoneg_set;
    __dispatch__portmod_port_autoneg_get_f                                           f_portmod_port_autoneg_get;
    __dispatch__portmod_port_autoneg_status_get_f                                    f_portmod_port_autoneg_status_get;
    __dispatch__portmod_port_link_get_f                                              f_portmod_port_link_get;
    __dispatch__portmod_port_link_latch_down_get_f                                   f_portmod_port_link_latch_down_get;
    __dispatch__portmod_port_phy_link_up_event_f                                     f_portmod_port_phy_link_up_event;
    __dispatch__portmod_port_phy_link_down_event_f                                   f_portmod_port_phy_link_down_event;
    __dispatch__portmod_port_prbs_config_set_f                                       f_portmod_port_prbs_config_set;
    __dispatch__portmod_port_prbs_config_get_f                                       f_portmod_port_prbs_config_get;
    __dispatch__portmod_port_prbs_enable_set_f                                       f_portmod_port_prbs_enable_set;
    __dispatch__portmod_port_prbs_enable_get_f                                       f_portmod_port_prbs_enable_get;
    __dispatch__portmod_port_prbs_status_get_f                                       f_portmod_port_prbs_status_get;
    __dispatch__portmod_port_nof_lanes_get_f                                         f_portmod_port_nof_lanes_get;
    __dispatch__portmod_port_ilkn_nof_segments_set_f                                 f_portmod_port_ilkn_nof_segments_set;
    __dispatch__portmod_port_ilkn_nof_segments_get_f                                 f_portmod_port_ilkn_nof_segments_get;
    __dispatch__portmod_ilkn_retranstmit_config_set_f                                f_portmod_ilkn_retranstmit_config_set;
    __dispatch__portmod_ilkn_retranstmit_config_get_f                                f_portmod_ilkn_retranstmit_config_get;
    __dispatch__portmod_port_lanes_assign_f                                          f_portmod_port_lanes_assign;
    __dispatch__portmod_port_lanes_retrieve_f                                        f_portmod_port_lanes_retrieve;
    __dispatch__portmod_port_firmware_mode_set_f                                     f_portmod_port_firmware_mode_set;
    __dispatch__portmod_port_firmware_mode_get_f                                     f_portmod_port_firmware_mode_get;
    __dispatch__portmod_port_runt_threshold_set_f                                    f_portmod_port_runt_threshold_set;
    __dispatch__portmod_port_runt_threshold_get_f                                    f_portmod_port_runt_threshold_get;
    __dispatch__portmod_port_max_packet_size_set_f                                   f_portmod_port_max_packet_size_set;
    __dispatch__portmod_port_max_packet_size_get_f                                   f_portmod_port_max_packet_size_get;
    __dispatch__portmod_port_pad_size_set_f                                          f_portmod_port_pad_size_set;
    __dispatch__portmod_port_pad_size_get_f                                          f_portmod_port_pad_size_get;
    __dispatch__portmod_port_tx_mac_sa_set_f                                         f_portmod_port_tx_mac_sa_set;
    __dispatch__portmod_port_tx_mac_sa_get_f                                         f_portmod_port_tx_mac_sa_get;
    __dispatch__portmod_port_rx_mac_sa_set_f                                         f_portmod_port_rx_mac_sa_set;
    __dispatch__portmod_port_rx_mac_sa_get_f                                         f_portmod_port_rx_mac_sa_get;
    __dispatch__portmod_port_tx_average_ipg_set_f                                    f_portmod_port_tx_average_ipg_set;
    __dispatch__portmod_port_tx_average_ipg_get_f                                    f_portmod_port_tx_average_ipg_get;
    __dispatch__portmod_port_tx_preamble_length_set_f                                f_portmod_port_tx_preamble_length_set;
    __dispatch__portmod_port_tx_preamble_length_get_f                                f_portmod_port_tx_preamble_length_get;
    __dispatch__portmod_port_local_fault_control_set_f                               f_portmod_port_local_fault_control_set;
    __dispatch__portmod_port_local_fault_control_get_f                               f_portmod_port_local_fault_control_get;
    __dispatch__portmod_port_remote_fault_control_set_f                              f_portmod_port_remote_fault_control_set;
    __dispatch__portmod_port_remote_fault_control_get_f                              f_portmod_port_remote_fault_control_get;
    __dispatch__portmod_port_local_fault_status_get_f                                f_portmod_port_local_fault_status_get;
    __dispatch__portmod_port_remote_fault_status_get_f                               f_portmod_port_remote_fault_status_get;
    __dispatch__portmod_port_local_fault_status_clear_f                              f_portmod_port_local_fault_status_clear;
    __dispatch__portmod_port_remote_fault_status_clear_f                             f_portmod_port_remote_fault_status_clear;
    __dispatch__portmod_port_pause_control_set_f                                     f_portmod_port_pause_control_set;
    __dispatch__portmod_port_pause_control_get_f                                     f_portmod_port_pause_control_get;
    __dispatch__portmod_port_pfc_control_set_f                                       f_portmod_port_pfc_control_set;
    __dispatch__portmod_port_pfc_control_get_f                                       f_portmod_port_pfc_control_get;
    __dispatch__portmod_port_llfc_control_set_f                                      f_portmod_port_llfc_control_set;
    __dispatch__portmod_port_llfc_control_get_f                                      f_portmod_port_llfc_control_get;
    __dispatch__portmod_port_update_f                                                f_portmod_port_update;
    __dispatch__portmod_port_core_access_get_f                                       f_portmod_port_core_access_get;
    __dispatch__portmod_port_phy_lane_access_get_f                                   f_portmod_port_phy_lane_access_get;
    __dispatch__portmod_port_duplex_set_f                                            f_portmod_port_duplex_set;
    __dispatch__portmod_port_duplex_get_f                                            f_portmod_port_duplex_get;
    __dispatch__portmod_port_phy_reg_read_f                                          f_portmod_port_phy_reg_read;
    __dispatch__portmod_port_phy_reg_write_f                                         f_portmod_port_phy_reg_write;
    __dispatch__portmod_port_reset_set_f                                             f_portmod_port_reset_set;
    __dispatch__portmod_port_reset_get_f                                             f_portmod_port_reset_get;
    __dispatch__portmod_port_adv_remote_get_f                                        f_portmod_port_adv_remote_get;
    __dispatch__portmod_port_drv_name_f                                              f_portmod_port_drv_name;
    __dispatch__portmod_port_drv_name_get_f                                          f_portmod_port_drv_name_get;
    __dispatch__portmod_port_fec_enable_set_f                                        f_portmod_port_fec_enable_set;
    __dispatch__portmod_port_fec_enable_get_f                                        f_portmod_port_fec_enable_get;
    __dispatch__portmod_port_ability_advert_set_f                                    f_portmod_port_ability_advert_set;
    __dispatch__portmod_port_ability_advert_get_f                                    f_portmod_port_ability_advert_get;
    __dispatch__portmod_port_ability_remote_get_f                                    f_portmod_port_ability_remote_get;
    __dispatch__portmod_port_frame_spacing_stretch_set_f                             f_portmod_port_frame_spacing_stretch_set;
    __dispatch__portmod_port_frame_spacing_stretch_get_f                             f_portmod_port_frame_spacing_stretch_get;
    __dispatch__portmod_port_diag_fifo_status_get_f                                  f_portmod_port_diag_fifo_status_get;
    __dispatch__portmod_port_rx_control_set_f                                        f_portmod_port_rx_control_set;
    __dispatch__portmod_port_rx_control_get_f                                        f_portmod_port_rx_control_get;
    __dispatch__portmod_port_pfc_config_set_f                                        f_portmod_port_pfc_config_set;
    __dispatch__portmod_port_pfc_config_get_f                                        f_portmod_port_pfc_config_get;
    __dispatch__portmod_port_eee_set_f                                               f_portmod_port_eee_set;
    __dispatch__portmod_port_eee_get_f                                               f_portmod_port_eee_get;
    __dispatch__portmod_port_eee_clock_set_f                                         f_portmod_port_eee_clock_set;
    __dispatch__portmod_port_eee_clock_get_f                                         f_portmod_port_eee_clock_get;
    __dispatch__portmod_port_vlan_tag_set_f                                          f_portmod_port_vlan_tag_set;
    __dispatch__portmod_port_vlan_tag_get_f                                          f_portmod_port_vlan_tag_get;
    __dispatch__portmod_port_modid_set_f                                             f_portmod_port_modid_set;
    __dispatch__portmod_port_led_chain_config_f                                      f_portmod_port_led_chain_config;
    __dispatch__portmod_port_clear_rx_lss_status_set_f                               f_portmod_port_clear_rx_lss_status_set;
    __dispatch__portmod_port_clear_rx_lss_status_get_f                               f_portmod_port_clear_rx_lss_status_get;
    __dispatch__portmod_xphy_lane_attach_to_pm_f                                     f_portmod_xphy_lane_attach_to_pm;
    __dispatch__portmod_xphy_lane_detach_from_pm_f                                   f_portmod_xphy_lane_detach_from_pm;
    __dispatch__portmod_ext_phy_lane_attach_to_pm_f                                  f_portmod_ext_phy_lane_attach_to_pm;
    __dispatch__portmod_ext_phy_lane_detach_from_pm_f                                f_portmod_ext_phy_lane_detach_from_pm;
    __dispatch__portmod_port_lag_failover_status_toggle_f                            f_portmod_port_lag_failover_status_toggle;
    __dispatch__portmod_port_lag_failover_loopback_set_f                             f_portmod_port_lag_failover_loopback_set;
    __dispatch__portmod_port_lag_failover_loopback_get_f                             f_portmod_port_lag_failover_loopback_get;
    __dispatch__portmod_port_mode_set_f                                              f_portmod_port_mode_set;
    __dispatch__portmod_port_mode_get_f                                              f_portmod_port_mode_get;
    __dispatch__portmod_port_encap_set_f                                             f_portmod_port_encap_set;
    __dispatch__portmod_port_encap_get_f                                             f_portmod_port_encap_get;
    __dispatch__portmod_port_higig_mode_set_f                                        f_portmod_port_higig_mode_set;
    __dispatch__portmod_port_higig_mode_get_f                                        f_portmod_port_higig_mode_get;
    __dispatch__portmod_port_higig2_mode_set_f                                       f_portmod_port_higig2_mode_set;
    __dispatch__portmod_port_higig2_mode_get_f                                       f_portmod_port_higig2_mode_get;
    __dispatch__portmod_port_config_port_type_set_f                                  f_portmod_port_config_port_type_set;
    __dispatch__portmod_port_config_port_type_get_f                                  f_portmod_port_config_port_type_get;
    __dispatch__portmod_port_trunk_hwfailover_config_set_f                           f_portmod_port_trunk_hwfailover_config_set;
    __dispatch__portmod_port_trunk_hwfailover_config_get_f                           f_portmod_port_trunk_hwfailover_config_get;
    __dispatch__portmod_port_trunk_hwfailover_status_get_f                           f_portmod_port_trunk_hwfailover_status_get;
    __dispatch__portmod_port_diag_ctrl_f                                             f_portmod_port_diag_ctrl;
    __dispatch__portmod_port_ref_clk_get_f                                           f_portmod_port_ref_clk_get;
    __dispatch__portmod_port_lag_failover_disable_f                                  f_portmod_port_lag_failover_disable;
    __dispatch__portmod_port_lag_remove_failover_lpbk_set_f                          f_portmod_port_lag_remove_failover_lpbk_set;
    __dispatch__portmod_port_lag_remove_failover_lpbk_get_f                          f_portmod_port_lag_remove_failover_lpbk_get;
    __dispatch__portmod_port_cntmaxsize_set_f                                        f_portmod_port_cntmaxsize_set;
    __dispatch__portmod_port_cntmaxsize_get_f                                        f_portmod_port_cntmaxsize_get;
    __dispatch__portmod_port_multi_get_f                                             f_portmod_port_multi_get;
    __dispatch__portmod_port_drain_cell_get_f                                        f_portmod_port_drain_cell_get;
    __dispatch__portmod_port_drain_cell_stop_f                                       f_portmod_port_drain_cell_stop;
    __dispatch__portmod_port_drain_cell_start_f                                      f_portmod_port_drain_cell_start;
    __dispatch__portmod_port_drain_cells_rx_enable_f                                 f_portmod_port_drain_cells_rx_enable;
    __dispatch__portmod_port_egress_queue_drain_rx_en_f                              f_portmod_port_egress_queue_drain_rx_en;
    __dispatch__portmod_port_mac_ctrl_set_f                                          f_portmod_port_mac_ctrl_set;
    __dispatch__portmod_port_txfifo_cell_cnt_get_f                                   f_portmod_port_txfifo_cell_cnt_get;
    __dispatch__portmod_port_egress_queue_drain_get_f                                f_portmod_port_egress_queue_drain_get;
    __dispatch__portmod_port_mac_reset_set_f                                         f_portmod_port_mac_reset_set;
    __dispatch__portmod_port_soft_reset_toggle_f                                     f_portmod_port_soft_reset_toggle;
    __dispatch__portmod_port_mac_reset_check_f                                       f_portmod_port_mac_reset_check;
    __dispatch__portmod_port_core_num_get_f                                          f_portmod_port_core_num_get;
    __dispatch__portmod_port_e2ecc_hdr_set_f                                         f_portmod_port_e2ecc_hdr_set;
    __dispatch__portmod_port_e2ecc_hdr_get_f                                         f_portmod_port_e2ecc_hdr_get;
    __dispatch__portmod_port_e2e_enable_set_f                                        f_portmod_port_e2e_enable_set;
    __dispatch__portmod_port_e2e_enable_get_f                                        f_portmod_port_e2e_enable_get;
    __dispatch__portmod_port_fallback_lane_get_f                                     f_portmod_port_fallback_lane_get;
    __dispatch__portmod_port_speed_get_f                                             f_portmod_port_speed_get;
    __dispatch__portmod_port_tsc_refclock_set_f                                      f_portmod_port_tsc_refclock_set;
    __dispatch__portmod_port_tsc_refclock_get_f                                      f_portmod_port_tsc_refclock_get;
    __dispatch__portmod_port_discard_set_f                                           f_portmod_port_discard_set;
    __dispatch__portmod_port_soft_reset_set_f                                        f_portmod_port_soft_reset_set;
    __dispatch__portmod_port_tx_down_f                                               f_portmod_port_tx_down;
    __dispatch__portmod_port_logical_lane_order_set_f                                f_portmod_port_logical_lane_order_set;
    __dispatch__portmod_port_logical_lane_order_get_f                                f_portmod_port_logical_lane_order_get;
    __dispatch__portmod_port_pgw_reconfig_f                                          f_portmod_port_pgw_reconfig;
    __dispatch__portmod_port_notify_f                                                f_portmod_port_notify;
    __dispatch__portmod_port_control_phy_timesync_set_f                              f_portmod_port_control_phy_timesync_set;
    __dispatch__portmod_port_control_phy_timesync_get_f                              f_portmod_port_control_phy_timesync_get;
    __dispatch__portmod_port_timesync_config_set_f                                   f_portmod_port_timesync_config_set;
    __dispatch__portmod_port_timesync_config_get_f                                   f_portmod_port_timesync_config_get;
    __dispatch__portmod_port_timesync_enable_set_f                                   f_portmod_port_timesync_enable_set;
    __dispatch__portmod_port_timesync_enable_get_f                                   f_portmod_port_timesync_enable_get;
    __dispatch__portmod_port_timesync_nco_addend_set_f                               f_portmod_port_timesync_nco_addend_set;
    __dispatch__portmod_port_timesync_nco_addend_get_f                               f_portmod_port_timesync_nco_addend_get;
    __dispatch__portmod_port_timesync_framesync_mode_set_f                           f_portmod_port_timesync_framesync_mode_set;
    __dispatch__portmod_port_timesync_framesync_mode_get_f                           f_portmod_port_timesync_framesync_mode_get;
    __dispatch__portmod_port_timesync_local_time_set_f                               f_portmod_port_timesync_local_time_set;
    __dispatch__portmod_port_timesync_local_time_get_f                               f_portmod_port_timesync_local_time_get;
    __dispatch__portmod_port_timesync_load_ctrl_set_f                                f_portmod_port_timesync_load_ctrl_set;
    __dispatch__portmod_port_timesync_load_ctrl_get_f                                f_portmod_port_timesync_load_ctrl_get;
    __dispatch__portmod_port_timesync_tx_timestamp_offset_set_f                      f_portmod_port_timesync_tx_timestamp_offset_set;
    __dispatch__portmod_port_timesync_tx_timestamp_offset_get_f                      f_portmod_port_timesync_tx_timestamp_offset_get;
    __dispatch__portmod_port_timesync_rx_timestamp_offset_set_f                      f_portmod_port_timesync_rx_timestamp_offset_set;
    __dispatch__portmod_port_timesync_rx_timestamp_offset_get_f                      f_portmod_port_timesync_rx_timestamp_offset_get;
    __dispatch__portmod_port_phy_intr_enable_set_f                                   f_portmod_port_phy_intr_enable_set;
    __dispatch__portmod_port_phy_intr_enable_get_f                                   f_portmod_port_phy_intr_enable_get;
    __dispatch__portmod_port_phy_intr_status_get_f                                   f_portmod_port_phy_intr_status_get;
    __dispatch__portmod_port_phy_intr_status_clear_f                                 f_portmod_port_phy_intr_status_clear;
    __dispatch__portmod_port_phy_timesync_do_sync_f                                  f_portmod_port_phy_timesync_do_sync;
    __dispatch__portmod_port_timesync_capture_timestamp_get_f                        f_portmod_port_timesync_capture_timestamp_get;
    __dispatch__portmod_port_timesync_heartbeat_timestamp_get_f                      f_portmod_port_timesync_heartbeat_timestamp_get;
    __dispatch__portmod_port_edc_config_set_f                                        f_portmod_port_edc_config_set;
    __dispatch__portmod_port_edc_config_get_f                                        f_portmod_port_edc_config_get;
    __dispatch__portmod_port_interrupt_enable_set_f                                  f_portmod_port_interrupt_enable_set;
    __dispatch__portmod_port_interrupt_enable_get_f                                  f_portmod_port_interrupt_enable_get;
    __dispatch__portmod_port_interrupt_get_f                                         f_portmod_port_interrupt_get;
    __dispatch__portmod_port_interrupts_get_f                                        f_portmod_port_interrupts_get;
    __dispatch__portmod_port_check_legacy_phy_f                                      f_portmod_port_check_legacy_phy;
    __dispatch__portmod_port_failover_mode_set_f                                     f_portmod_port_failover_mode_set;
    __dispatch__portmod_port_failover_mode_get_f                                     f_portmod_port_failover_mode_get;
    __dispatch__portmod_port_mac_rsv_mask_set_f                                      f_portmod_port_mac_rsv_mask_set;
    __dispatch__portmod_port_mib_reset_toggle_f                                      f_portmod_port_mib_reset_toggle;
    __dispatch__portmod_port_warmboot_db_restore_f                                   f_portmod_port_warmboot_db_restore;
    __dispatch__portmod_port_flow_control_set_f                                      f_portmod_port_flow_control_set;
    __dispatch__portmod_port_update_dynamic_state_f                                  f_portmod_port_update_dynamic_state;
    __dispatch__portmod_port_phy_op_mode_get_f                                       f_portmod_port_phy_op_mode_get;
    __dispatch__portmod_port_lane_map_set_f                                          f_portmod_port_lane_map_set;
    __dispatch__portmod_port_lane_map_get_f                                          f_portmod_port_lane_map_get;
    __dispatch__portmod_port_polarity_set_f                                          f_portmod_port_polarity_set;
    __dispatch__portmod_port_polarity_get_f                                          f_portmod_port_polarity_get;
    __dispatch__portmod_port_medium_config_set_f                                     f_portmod_port_medium_config_set;
    __dispatch__portmod_port_medium_config_get_f                                     f_portmod_port_medium_config_get;
    __dispatch__portmod_port_medium_get_f                                            f_portmod_port_medium_get;
    __dispatch__portmod_pm_is_in_pm12x10_f                                           f_portmod_pm_is_in_pm12x10;
    __dispatch__portmod_slow_read_rate_set_f                                         f_portmod_slow_read_rate_set;
    __dispatch__portmod_port_pll_div_get_f                                           f_portmod_port_pll_div_get;
    __dispatch__portmod_port_master_get_f                                            f_portmod_port_master_get;
    __dispatch__portmod_port_lane_count_get_f                                        f_portmod_port_lane_count_get;
} __portmod__dispatch__t__;

extern __portmod__dispatch__t__* __portmod__dispatch__[portmodDispatchTypeCount];

#endif /*_PORTMOD_DISPATCH_H_*/
